#!/bin/bash
##############################################################################
#                 ETL ݺ SCRIPT                                  #
##############################################################################
#                                                                            #
#   Shell Name      :                                                        #
#                                                                            #
#   Descriptions    : Ⱓ ݺ ǰ .                   #
#                                                                            #
#   Modification                                                             #
#    Date        SE       DESC.                                              #
#   ------------ ------- --------------------------------------------------  #
#    2020-12-10  kmoh     Initial                                            #
#                                                                            #
##############################################################################

##############################################################################

DT_START=$1   #YYYYMMDD (startdate)
DT_END=$2     #YYYYMMDD (enddate)

sdt=`date -d "-3 days" +"%Y%m%d"`
edt=`date -d "-1 days" +"%Y%m%d"`
pastmon_firstdt=`date -d "-1 month" +"%Y%m"`"01"
pastmon_lastdt=`date -d "-$(date +%d) days -0 month" +"%Y%m%d"`

WK=`date +%w`

usr="root"
db="etl"
pwd="retail2020!"
	 
 # sunday : -4 Ddays  , others  : -3 Days
if [ "$WK" = "0" ]; then
      sdt=`date -d "-4 days" +"%Y%m%d"`
fi

 if [ "$1" == "" ] && [ "$2" == "" ];  then
    DT_START=${sdt}
    DT_END=${edt}
 elif  [ "$1" ==  ""  ]; then
    DT_START=${sdt}
    DT_END=${edt}
 elif  [ "$1" ==  "M"  ]; then
     DT_START=${pastmon_firstdt}
    DT_END=${pastmon_lastdt} 
 elif  [ "$2" ==  ""  ]; then
    DT_END=$1
 else
    DT_START=$1
    DT_END=$2
 fi



##############################################################################
#  ETL ݺ  : INITIALIZATION.                                          #
##############################################################################
 sid="`hostname`:"; wmark="   "; emark="!!!"; work="۾..."; fail=".";
 rtn=0

 echo ""
 echo "    ======== ۾ : `date +'(%H:%M:%S)'` ݺ ۾  ($DT_START - $DT_END) ======="

###########################################################################
#   MAIN LINE.                                                            #
###########################################################################
#=============================================================================
 days=1                    # ETL ϼ (ϰ   ϼ)

 continue="YES"            # Ұ
 ix=0                      # Ұ

 tdate=$DT_START           #  (YYYYMMDD)

#--------------------------------------------------------------------------------------------------
 echo "    ϼ : $days (Ⱓ ݺ ǰ )"
 echo ""


#--------------------------------------------------------------------------------------------------
 while [[ $continue = "YES" ]]
 do
     pnm="LOOP óⰣ "; pid="(dbaccess)";


	 
	 dterm=`echo "SELECT DATE_FORMAT(INTERVAL $ix DAY + '$tdate','%Y%m%d')  AS fdate,  DATE_FORMAT(INTERVAL ( $ix + $days -1 ) DAY  + '$tdate','%Y%m%d') as tdate  " |  mysql -u ${usr} -D ${db} -p${pwd}  --skip-column-names `
	 echo $dterm
	 
	 if [[ "$dterm" == "" ]]; then echo $emark $sid $pid $pnm $fail; exit -1; fi

     if [ $? -ne 0 ]; then echo $emark $sid $pid $pnm $fail; exit -1; fi

     fdate=`echo $dterm  | awk '{print $1}'`            # from date
     tdate=`echo $dterm  | awk '{print $2}'`            # to date
	 
	if [[ ! ($tdate < $DT_END) ]]; then tdate=$DT_END; continue="NO"; fi

     ix=1

     #-----------------------------------------------------------------------------
      pnm="LOOP ETL"; pid="(total_mart_tb_ft_ofl_tr_item.sh)";

      echo "hive -f /etl/external/hiv/total_mart_tb_ft_ofl_tr_item.hql     --hivevar FromDT=${fdate}  --hivevar ToDT=${tdate} "



      if [ $? -ne 0 ]; then echo $emark $sid $pid $pnm $fail; exit -1; fi
     #-----------------------------------------------------------------------------
      echo "   +"

 done

##########################################################################
#   FINALIZATION.                                                        #
##########################################################################

 echo "    ======== ۾ : `date +'(%H:%M:%S)'` ݺ ۾  ($DT_START - $DT_END) ======="
 echo ""
 exit $rtn;

